""" module loader. """

import logging
import importlib
import inspect
import obj
import os
import pkgutil
import time
import types

handlers = {}
table = {}

class Loader(obj.Object):

    def cached(self, name):
        global table
        if name not in table:
            table[name] = self.direct(name) 
        return table[name]

    def direct(self, name, package=None):
        logging.warn("load %s" % name)
        try:
            p, m = name.split(" .", 1) 
            return importlib.import_module(m, p)
        except ValueError:
            return importlib.import_module(name)

    def get_handler(self, cmd):
        val = handlers.get(cmd, None)
        if not val:
            modname = obj.names.get(cmd, None)
            if modname:
                self.load_mod(modname)
            val = handlers.get(cmd, None)
        return val

    def init(self, m):
        func = getattr(m, "init", None)
        if func:
            return obj.launch(func)

    def load_mod(self, name, mod=None):
        global handlers
        mod = mod or self.cached(name)
        for key, func, modname in self.scan_commands(mod):
            handlers[key] = func
            obj.names[key] = modname
        #for key, cls, modname in self.scan_classes(mod):
        #    obj.modnames[key] = modname
        #    obj.classes[key.lower()] = "%s.%s" % (modname, key)
        #    name = "%s.%s" % (modname, key)
        #    if name not in obj.types:
        #        obj.types.append(name)
        return mod

    def register(self, cmd, handler):
        handlers[cmd] = handler

    def scan_commands(self, mod):
        for key in dir(mod):
            if key.startswith("_"):
                continue
            o = getattr(mod, key, None)
            if o and isinstance(o, types.FunctionType):
                if "event" in o.__code__.co_varnames:
                    yield (key, o, mod.__name__)

    def scan_classes(self, mod):
        for key in dir(mod):
            if key.startswith("_"):
                continue
            o = getattr(mod, key, None)
            if o and isinstance(o, obj.Object):
                yield (key, o, mod.__name__)

    def unload(self, modname):
        global handlers, table
        if modname in table:
            mod = table[modname]
        for key, func, name in self.scan(mod):
            if name == modname:
                try:
                    del handlers[key]
                    del names[key]
                except KeyError:
                    pass

    def walk(self, modname, init=False):
        logging.warn("walking %s" % modname)
        thrs = []
        mod = self.load_mod(modname)
        if init and "init" in dir(mod):
            thrs.append(obj.launch(mod.init))
        for m in dir(mod):
            module = getattr(mod, m)
            if type(module) != types.ModuleType:
                continue
            self.load_mod(module.__name__, module)
            if init and "init" in dir(module):
                logging.error("init %s" % module.__name__)
                thrs.append(launch(module.init))
        return thrs
